'use strict'

process.env.NODE_PATH = __dirname
require('module')
  .Module._initPaths()

const net = require('net')
const log = require('lib/log')
const Client = require('lib/Client')
const connection = require('lib/rethinkdb-connection')

const Server = function () {
  var that = this

  this.start = function () {
    var server = net.createServer(function (socket) {
      new Client(that, socket)
    })

    server.listen(this.port)
    server.on('error', console.log)
  }

  this.permissions = {
    collection: {},
    event: {},
    rpc: {}
  }
}

Server.prototype.connection = require('lib/rethinkdb-connection')
Server.prototype.config = require('src/config/config')
Server.prototype.collection = require('src/config/collection')
Server.prototype.rpc = require('src/config/rpc')
Server.prototype.event = require('src/config/event')

module.exports = Server
