'use strict'

const log = console.log
const HydroSocket = require('lib/were-socket')


module.exports = function (server, socket) {
  log('[CLIENT_CONNECTED]')

  this.socket = new HydroSocket(socket)
  this.server = server

  require('src/auth/login').call(this)

  require('src/collection/count').call(this)
  require('src/collection/find').call(this)
  require('src/collection/store').call(this)
  require('src/collection/update').call(this)
  require('src/collection/upsert').call(this)

  require('src/rpc/make').call(this)
  require('src/rpc/provide').call(this)

  require('src/event/emit').call(this)
  require('src/event/subscribe').call(this)
  require('src/event/unsubscribe').call(this)
}
