'use strict'

const C = require('were-constants')

module.exports = function (options) {
  if (!options.hasOwnProperty('topic'))
    options.topic = '[A-Z]{1}';

  if (!options.hasOwnProperty('action'))
    options.action = '[A-Z]{1,3}';

  if (!options.hasOwnProperty('id'))
    options.id = '[a-z0-9]{10}';

  if (!options.hasOwnProperty('name'))
    options.name = `[^${C.MESSAGE_PART_SEPERATOR}]*`;

  if (!options.hasOwnProperty('data'))
    options.data = `[^${C.MESSAGE_PART_SEPERATOR}]*`;
  else options.data = JSON.stringify(options.data);

  return new RegExp('^' + [
    options.topic,
    options.action,
    options.id,
    options.name,
    options.data
  ].join(C.MESSAGE_PART_SEPERATOR) + '$')
}
