'use strict'

var scribe = require('scribe-js')({
  createDefaultConsole: false
})

var app = require('lib/express')
app.use('/logs', scribe.webPanel())

const log = scribe.console({
  console: {
    alwaysTime: true,
    alwaysTags: true,
    alwaysLocation: true,
    colors: 'white'
  }
})

log.addLogger('error', null, {
  defaultTags: ['ERROR'],
  tagsColors: 'red',
  colors: 'red'
})

log.addLogger('warn', null, {
  defaultTags: ['WARN'],
  tagsColors: 'yellow',
  colors: 'yellow'
})

log.addLogger('info', null, {
  defaultTags: ['INFO'],
  tagsColors: 'gray'
})

log.addLogger('debug', null, {
  defaultTags: ['DEBUG'],
  tagsColors: 'gray'
})

module.exports = log
