'use strict'

var kue = require('kue')
var ui = require('kue-ui')
var app = require('lib/express')
var RedisPubSub = require('node-redis-pubsub');

module.exports.events = new RedisPubSub({
  port: 6379,
  scope: 'events'
})

ui.setup({
  apiURL: '/api',
  baseURL: '/kue',
  updateInterval: 5000
})

app.use('/api', kue.app)
app.use('/kue', ui.app)

module.exports.rpc = kue.createQueue()
