'use strict'

const C = require('were-constants')
const log = require('lib/log')

module.exports = function () {

  var self = this
  var server = this.server
  var socket = this.socket

  socket.subscribe({
    topic: C.TOPIC.AUTH,
    action: C.ACTION.REQUEST
  }, function (topic, action, id, name, data) {

    if (server.authenticationHandler)
      server.authenticationHandler(data, function (err, data) {
        if (err)
          return socket.send({
            topic: C.TOPIC.AUTH,
            action: C.ACTION.DENIED,
            id: id,
            data: err
          })

        return socket.send({
          topic: C.TOPIC.AUTH,
          action: C.ACTION.GRANTED,
          id: id,
          data: data
        })
      })
  })
}
