'use strict'

const C = require('were-constants')
const queue = require('lib/queue')
const log = require('lib/log')
const db = require('rethinkdb')

module.exports = function () {
  var server = this.server
  var socket = this.socket

  socket.subscribe({
    action: C.ACTION.COUNT
  }, function (topic, action, id, name, data) {

    server.connection().then(function (conn) {

      var query = db.table(name)

      if (data.get) query = query.get(data.get);
      if (data.filter) query = query.filter(data.filter);

      query = query.count()

      query.run(conn, function (err, result) {
        if (err) return console.log(err);

        socket.send({
          topic: topic,
          action: action,
          id: id,
          name: name,
          data: result
        })
      })
    })
  })
}
