'use strict'

const C = require('were-constants')
const queue = require('lib/queue')
const log = require('lib/log')
const db = require('rethinkdb')

module.exports = function () {
  var server = this.server
  var socket = this.socket

  socket.subscribe({
    action: C.ACTION.FIND
  }, function (topic, action, id, name, data) {

    server.connection().then(function (conn) {

      var query = db.table(name)

      if (data.get) query = query.get(data.get);
      if (data.filter) query = query.filter(data.filter);

      if (topic === C.TOPIC.WATCH)
        query = query.changes({
          includeInitial: true
        });

      var returnresult = function (result) {

        socket.send({
          topic: topic,
          action: action,
          id: id,
          name: name,
          data: result
        })
      }

      query.run(conn, function (err, result) {
        if (err) return console.log(err);

        if (result.each)
          return result.each(function (err, result) {
            if (result.new_val)
              result = result.new_val;

            returnresult(result)
          });

        returnresult(result)
      })

      socket.send({
        topic: topic,
        action: C.ACTION.ACK,
        id: id
      })
    })
  })
}
