'use strict'

const C = require('were-constants')
const queue = require('lib/queue')
const log = require('lib/log')
const db = require('rethinkdb')

module.exports = function () {
  var server = this.server
  var socket = this.socket

  socket.subscribe({
    topic: C.TOPIC.WRITE,
    action: C.ACTION.STORE
  }, function (topic, action, id, name, data) {

    server.connection().then(function (conn) {

      db.table(name)
        .insert(data.store)
        .run(conn, function (err, result) {
          if (err) return console.log(err);
        })
    })
  })
}
