'use strict'

const C = require('were-constants')
const queue = require('lib/queue')
const log = require('lib/log')
const db = require('rethinkdb')

module.exports = function () {
  var server = this.server
  var socket = this.socket

  socket.subscribe({
    topic: C.TOPIC.WRITE,
    action: C.ACTION.UPDATE
  }, function (topic, action, id, name, data) {

    server.connection().then(function (conn) {

      var query = db.table(name)

      if (data.get) query = query.get(data.get);
      if (data.filter) query = query.filter(data.filter);

      query = query.update(data.update)

      query.run(conn, function (err, result) {
        if (err) return console.log(err);
      })
    })
  })
}
