'use strict'

const C = require('were-constants')
const queue = require('lib/queue')
const log = require('lib/log')

module.exports = function () {

  var socket = this.socket

  socket.subscribe({
    topic: C.TOPIC.RPC,
    action: C.ACTION.REQUEST
  }, function (topic, action, id, name, data) {

    queue.rpc.create(name, {
        id: id,
        data: data
      })
      .removeOnComplete(true)
      .save()
      .on('complete', function (result) {
        socket.send(result)
      })

  })
}
