'use strict'

const C = require('were-constants')
const queue = require('lib/queue')
const log = require('lib/log')

module.exports = function () {

  var socket = this.socket

  socket.subscribe({
    topic: C.TOPIC.RPC,
    action: C.ACTION.SUBSCRIBE
  }, function (topic, action, id, name, data) {

    var worker

    socket.subscribe({
      topic: C.TOPIC.RPC,
      action: C.ACTION.UNSUBSCRIBE
    }, function (topic, action, id, name, data) {
      worker.shutdown()
    })

    queue.rpc.process(name, function (task, ctx, done) {

      worker = ctx

      socket.send({
        topic: C.TOPIC.RPC,
        action: C.ACTION.REQUEST,
        id: task.data.id,
        name: name,
        data: task.data.data
      })

      socket.subscribe({
        id: task.data.id
      }, function (topic, action, id, name, data) {

        done(null, {
          topic: topic,
          action: action,
          id: id,
          name: name,
          data: data
        })

        socket.unsubscribe({
          id: task.data.id
        })
      })
    })
  })
}
